//=============================================================================
// MazeConvert                                     by elementarySoftworks 1997
// 1.2
//-----------------------------------------------------------------------------
// MazeConvert.cc,v 1.2 1997/05/20 23:23:58 tim Exp
// MazeConvert.cc,v
// Revision 1.2  1997/05/20 23:23:58  tim
// bin->ASCII konvertierung debugged
//
// Revision 1.1  1997/05/19 12:02:52  tim
// Initial revision
//
//=============================================================================

static char versioninfo[] = "MazeConvert.cc,v 1.2 1997/05/20 23:23:58 tim Exp";

#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <fstream.h>
#include <iostream.h>
#include <strstream.h>


// ., = offen        (unsichtbar, passierbar,   nicht schussicher)
// sS = Schutzschild (unsichtbar, passierbar,   schussicher)
// +* = Lichtvorhang (unsichtbar, unpassierbar, nicht schussicher)
// wW = Fenster      (unsichtbar, unpassierbar, schussicher)
// oO = Vorhang      (sichtbar,   passierbar,   nicht schussicher)
// xX = Tuer         (sichtbar,   passierbar,   schussicher)
// fF = Zaun         (sichtbar,   unpassierbar, nicht schussicher)
// ## = Wand         (sichtbar,   unpassierbar, schussicher)

//    ^v
//    ## ## ## ##
//  >#  .  .  .  .
//  <#  .  .  .  .
//    .. .. .. ..
//   #  .  .  .  .
//   #  .  .  .  .
//    .. .. .. ..

#define  RED      8
#define  GREEN    9
#define  BLUE    10
#define  BROWN   11
#define  CYAN    12
#define  PINK    13
#define  MAGENTA 14
#define  BEIGE   15


#define  WALL_0 1
#define  WALL_1 2
#define  WALL_2 3

#define  FENCE_0 4
#define  FENCE_1 5
#define  FENCE_2 6
#define  FENCE_3 7

#define  DOOR_0 MAGENTA
#define  DOOR_1 BEIGE
#define  DOOR_2 BLUE
#define  DOOR_3 BROWN

#define  CURTAIN_0 RED
#define  CURTAIN_1 CYAN
#define  CURTAIN_2 PINK
#define  CURTAIN_3 GREEN

#define  HELP1_TEXT "\
MazeConvert   (by elementarySoftworks 1997, 1.2)\n\
\n\
converts ASCII-input into iMazeLab1-BINARY-output and\n\
         iMazeLab1-BINARY-input into ASCII-output"

#define  HELP2_TEXT "[sourcefile [destinationfile]] | -h | -help | -HELP"

#define  HELP3_TEXT "\
-h:              print version & brief help\n\
-help:           print this help\n\
-HELP:           print detailed help (info on file-formats included)\n\
sourcefile:      name of the inputfile. If omitted input is taken from stdin\n\
destinationfile: name of the outputfile. If omitted output is directed to\n\
                 stdout (it is not possible to specify the destination if\n\
                 the source is taken from stdin)\n\
\n\
MazeConvert automatically detects the input-format. If the input starts with\n\
'iMazeLab1' it converts BINARY to ASCII, otherwise it converts ASCII to BINARY"

#define  HELP4_TEXT "\
The binary format is conform to the maze-file-format of the famous game\n\
'imaze' (standard file-extension: .lab).\n\
The ASCII-format makes the imaze-mazes editable with any text-editor. It\n\
is possible to create invisible walls (= windows), non-bulletproof walls and\n\
many other fine things (the two sides of the walls are independent to each\n\
other, so it is possible to create walls which are invisible on the first\n\
side and non-bulletproof on the other...); imazesrv will print out a warning\n\
(it don't like invisible walls), but nevertheless it will work fine.\n\
\n\
This is the format of the ASCII-file:\n\
Lines starting with '!' are comments. They will be put at the end of the\n\
  binary maze-file (without leading '!', of course).\n\
Lines starting with ':' are maze definitions, the will be converted to\n\
  binary output.\n\
All other lines will be ignored by MazeConvert.\n\
\n\
The size of the maze is detected automatically on the number and the\n\
length of the maze-definition-lines (so the lines must\n\
end directly after the last wall).\n\
\n\
The maze consists of fields surrounded by walls. The type of the walls\n\
is specified by the followingASCII-Characters:\n\
 . , = no wall       (invisible, passable,   non-bulletproof)\n\
 s S = shield        (invisible, passable,   bulletproof)\n\
 + * = light-curtain (invisible, impassable, non-bulletproof)\n\
 w W = window        (invisible, impassable, bulletproof)\n\
 o O = curtain       (visible,   passable,   non-bulletproof)\n\
 x X = door          (visible,   passable,   bulletproof)\n\
 f F = fence         (visible,   impassable, non-bulletproof)\n\
 # # = wall          (visible,   impassable, bulletproof)\n\
passable: it is possible to move through the wall from (at least) this side\n\
    to the other side (it depends on the type of the other side of the wall\n\
    wether you can step back again or not (one-way-door))\n\
non-bulletproof: it is possible to shoot through the wall from (at least)\n\
    this side to the other (although you possibly can't see through it)\n\
visible: you can't see through the wall (although you possibly can shoot or\n\
    walk through it)\n\
The first column letters (small) are used to specify 'hidden' walls which\n\
are not marked on the other side, the second column letters (capital) are\n\
used to specify walls whose special function is shown on the backside by\n\
using a different colour (or lighter gray). The behaviour of the walls is\n\
always marked on the front side (all visible passable walls are colored,\n\
impassable walls are displayed in grayscale).\n\
\n\
The two sides of the four surrounding walls of each field are specified\n\
like this:\n\
  io    i = wall behavior from inside\n\
 o  i   o = wall behavior from outside\n\
 i  o\n\
  oi    adjacent fields share the wall between themselves like this:\n\
\n\
: ## ##     This is a correct definition of a 2x1-maze.\n\
:#  o  #    You can shoot from the left to the right side but not from the\n\
:#  X  #    right to the left side. You can walk through the wall in both\n\
: ## ##     directions. You can't recognize the 'curtain-behaviour' of the\n\
            left side of the wall on the right side, even though the left\n\
side shows that it is possible to move through the wall from the right to\n\
the left.\n"



int bColourFits (unsigned char cTestIt)
{
  if (cTestIt & 15) 
    {
      if (cTestIt & 128)
        {
          if (cTestIt & 64)  // Wand
            return ((cTestIt & 15) == WALL_0);
          else // Zaun
            return ((cTestIt & 15) == FENCE_0);
        }
      else
        {
          if (cTestIt & 64)  // Tuer
            return ((cTestIt & 15) == DOOR_0);
          else // Vorhang
            return ((cTestIt & 15) == CURTAIN_0);
        }
    }
  return 1;
}

int iGetValue (const char cThisSide, const char cOtherSide)
{
  int iValue;
  switch (cThisSide)
    {
    case '#':     // Wand: sichtbar, unpassierbar, schussicher
      iValue = 128 | 64;
      switch (cOtherSide)
        {
        case ',': iValue |= WALL_2; break;
        case 'S': iValue |= WALL_1; break;
        case '*': iValue |= WALL_2; break;
        case 'W': iValue |= WALL_0; break;
        case 'O': iValue |= WALL_2; break;
        case 'X': iValue |= WALL_1; break;
        case 'F': iValue |= WALL_2; break;
        default:  iValue |= WALL_0; break;
        };
      break;
      
    case 'f':
    case 'F':     // Zaun: sichtbar, unpassierbar, nicht schussicher
      iValue = 128;
      switch (cOtherSide)
        {
        case ',': iValue |= FENCE_3; break;
        case 'S': iValue |= FENCE_2; break;
        case '*': iValue |= FENCE_3; break;
        case 'W': iValue |= FENCE_1; break;
        case 'O': iValue |= FENCE_3; break;
        case 'X': iValue |= FENCE_2; break;
        case 'F': iValue |= FENCE_3; break;
        default:  iValue |= FENCE_0; break;
        };
      break;
      
    case 'x':
    case 'X':     // Tuer: sichtbar, passierbar, schussicher
      iValue = 64;
      switch (cOtherSide)
        {
        case ',': iValue |= DOOR_3; break;
        case 'S': iValue |= DOOR_2; break;
        case '*': iValue |= DOOR_3; break;
        case 'W': iValue |= DOOR_1; break;
        case 'O': iValue |= DOOR_3; break;
        case 'X': iValue |= DOOR_2; break;
        case 'F': iValue |= DOOR_3; break;
        default:  iValue |= DOOR_0; break;
        };
      break;
      
    case 'o':
    case 'O':     // Vorhang: sichtbar, passierbar, nicht schussicher
      iValue = 0;
      switch (cOtherSide)
        {
        case ',': iValue |= CURTAIN_3; break;
        case 'S': iValue |= CURTAIN_2; break;
        case '*': iValue |= CURTAIN_3; break;
        case 'W': iValue |= CURTAIN_1; break;
        case 'O': iValue |= CURTAIN_3; break;
        case 'X': iValue |= CURTAIN_2; break;
        case 'F': iValue |= CURTAIN_3; break;
        default:  iValue |= CURTAIN_0; break;
        };
      break;
      
    case 'w':
    case 'W':     // Fenster: unsichtbar, unpassierbar, schussicher
      iValue = 128 | 64;
      break;
      
    case '+':
    case '*':     // Lichtvorhang: unsichtbar, unpassierbar, nicht schussicher
      iValue = 128;
      break;
      
    case 's':
    case 'S':     // Schutzschild: unsichtbar, passierbar, schussicher
      iValue = 64;
      break;
      
    case '.':
    case ',':     // offen: unsichtbar, passierbar, nicht schussicher
      iValue = 0;
      break;

    default:  iValue = 0;
    }      

  return iValue;
}


char cGetChar (int iInside, int iOutside)
{
  if (iInside & 15)
    {
      // sichtbar
      if (iInside & 128)
        {
          // Wand
          if (iInside & 64)
            {
              return bColourFits (iOutside) ? '#' : '#';
            }
          else // Zaun
            {
              return bColourFits (iOutside) ? 'f' : 'F';
            }
        }
      else
        {
          // Tuer
          if (iInside & 64)
            {
              return bColourFits (iOutside) ? 'x' : 'X';
            }
          else // Vorhang
            {
              return bColourFits (iOutside) ? 'o' : 'O';
            }
        }
    }
  else
    {
      // unsichtbar
      if (iInside & 128)
        {
          // Fenster
          if (iInside & 64)
            {
              return bColourFits (iOutside) ? 'w' : 'W';
            }
          else // Lichtvorhang
            {
              return bColourFits (iOutside) ? '+' : '*';
            }
        }
      else
        {
          // Schutzschild
          if (iInside & 64)
            {
              return bColourFits (iOutside) ? 's' : 'S';
            }
          else // offen
            {
              return bColourFits (iOutside) ? '.' : ',';
            }
        }
    }
}





int main (int argc, char* argv [])
{
  ifstream*    srcFile = NULL;
  ofstream*    dstFile = NULL;
  istream*     srcStream = NULL;
  ostream*     dstStream = NULL;
  strstream    sComment;
  char*        pcDummy;
  char         cInput[4][1001];

  char  cBinLab[128][128][4];
  int   iInner;
  int   iOuter;
  int   iLabSizeX = 0;
  int   iLabSizeY = 0;
  int   iLabLine = 0;


  if (argc > 1)
    {
      if (strncasecmp (argv[1], "-h", 2) == 0)
        {
          cout << HELP1_TEXT << endl << endl;

          cout << "usage: " << argv[0] << HELP2_TEXT << endl << endl;

          if (strcmp (argv[1], "-h") == 0)
            cout << " (more detailed help with option '-help')" << endl;
          else if (strcmp (argv[1], "-help") == 0)
            {
              cout << HELP3_TEXT << endl << endl;
              cout << " (help on file-formats with option '-HELP')" << endl;
            }
          else if (strcmp (argv[1], "-HELP") == 0)
            {
              cout << HELP3_TEXT << endl << endl;
              cout << HELP4_TEXT << endl;
            }

          return 0;
        }
      
      srcFile = new ifstream;
      srcFile->open (argv[1]);

      if (argc > 2)
        {
          dstFile = new ofstream;
          dstFile->open (argv[2]);
        }
    }

  if (srcFile)
    srcStream = srcFile;
  else
    srcStream = &cin;

  if (dstFile)
    dstStream = dstFile;
  else
    dstStream = &cout;



  for (iOuter = 0; iOuter < 128; iOuter++)
    for (iInner = 0; iInner < 128; iInner++)
      {
        cBinLab[iOuter][iInner][0] = 0;
        cBinLab[iOuter][iInner][1] = 0;
        cBinLab[iOuter][iInner][2] = 0;
        cBinLab[iOuter][iInner][3] = 0;
      }

  
  srcStream->getline (cInput[iLabLine], 1000, '\n');

  if (strcmp (cInput[iLabLine], "iMazeLab1"))
    {
      cerr << "converting ASCII to BINARY" << endl;

      while (!srcStream->eof ())
        {
          
          if (cInput[iLabLine][0] == ':')
            {
              iLabLine++;
              
              // Feldzeile komplett
              if (iLabLine >= 4)
                {
                  const int iMaxLoop = (strlen (cInput[1]) + 1) / 3;
                  for (iInner = 0; 
                       ((iInner < iMaxLoop) &&
                        (iInner < 128));
                       iInner++)
                    {
                      const int iFieldPos = 3 * iInner;
                      cBinLab[iInner][iLabSizeY][0] =
                        iGetValue (cInput[0][iFieldPos + 2],
                                   cInput[0][iFieldPos + 3]);
                      cBinLab[iInner][iLabSizeY][1] =
                        iGetValue (cInput[2][iFieldPos + 1],
                                   cInput[1][iFieldPos + 1]);
                      cBinLab[iInner][iLabSizeY][2] =
                        iGetValue (cInput[3][iFieldPos + 3],
                                   cInput[3][iFieldPos + 2]);
                      cBinLab[iInner][iLabSizeY][3] =
                        iGetValue (cInput[1][iFieldPos + 4],
                                   cInput[2][iFieldPos + 4]);
                    }
                  iLabSizeY++;
                  iLabSizeX = (iInner-1 > iLabSizeX) ? iInner-1 : iLabSizeX;
                  
                  // Letzte Zeile wird erste der n"achsten Feldzeile
                  strncpy (cInput[0], cInput[3], 1000);
                  iLabLine = 1;
                }
            }
          else if (cInput[iLabLine][0] == '!')
            {
              sComment << cInput[iLabLine]+1 << endl;
            }
          
          srcStream->getline (cInput[iLabLine], 1000, '\n');
        }

      *dstStream << "iMazeLab1" << endl;
      *dstStream << ((char) iLabSizeX) << ((char) iLabSizeY);
      
      for (iOuter = 0; iOuter < iLabSizeY; iOuter++)
        for (iInner = 0; iInner < iLabSizeX; iInner++)
          {
            *dstStream << cBinLab[iInner][iOuter][0] 
                       << cBinLab[iInner][iOuter][1]
                       << cBinLab[iInner][iOuter][2]
                       << cBinLab[iInner][iOuter][3];
          }
      
      sComment << '\0';
      pcDummy = sComment.str();
      if (pcDummy[0] != '\0')
        *dstStream << endl << pcDummy;
      
      delete pcDummy;
      
      *dstStream << "converted by elementarySoftwork's MazeConvert" << endl;
    }
  else
    {
      unsigned char iMaxX;
      unsigned char iMaxY;

      srcStream->get (iMaxX);
      srcStream->get (iMaxY);

      cerr << "converting " << (int) iMaxX << 'x' << (int) iMaxY
           << " BINARY to ASCII" << endl;


      for (iOuter = 0; iOuter < iMaxY; iOuter++)
        {
          for (iInner = 0; iInner < iMaxX; iInner++)
            {
              srcStream->get(cBinLab[iInner][iOuter][0]);
              srcStream->get(cBinLab[iInner][iOuter][1]);
              srcStream->get(cBinLab[iInner][iOuter][2]);
              srcStream->get(cBinLab[iInner][iOuter][3]);
            }
        }

      srcStream->getline (cInput[iLabLine], 1000, '\n');
      while (!srcStream->eof ())
        {
          if (cInput[iLabLine][0] != '\0')
            sComment << '!' << cInput[iLabLine] << endl;
          srcStream->getline (cInput[iLabLine], 1000, '\n');
        }

      *dstStream << ':';
      for (iOuter = 0; iOuter < iMaxX; iOuter++)
        *dstStream << " ##";

      for (iOuter = 0; iOuter < iMaxY; iOuter++)
        {
          *dstStream << endl << ":#  ";

          // Seitenwaende von links gesehen
          for (iInner = 1; iInner < iMaxX; iInner++)
            {
              *dstStream << cGetChar (cBinLab[iInner-1][iOuter][3],
                                      cBinLab[iInner  ][iOuter][1]) << "  ";
            }
          *dstStream << '#' << endl << ":#  ";
          
          // Seitenwaende von rechts gesehen
          for (iInner = 1; iInner < iMaxX; iInner++)
            {
              *dstStream << cGetChar (cBinLab[iInner  ][iOuter][1],
                                      cBinLab[iInner-1][iOuter][3]) << "  ";
            }
          *dstStream << '#' << endl << ':';

          // Decke und Boden
          if (iOuter < iMaxY-1)
            {
              for (iInner = 0; iInner < iMaxX; iInner++)
                {
                  // Decke
                  *dstStream << ' '
                             << cGetChar (cBinLab[iInner][iOuter+1][0],
                                          cBinLab[iInner][iOuter  ][2]);
                  // Boden
                  *dstStream << cGetChar (cBinLab[iInner][iOuter  ][2],
                                          cBinLab[iInner][iOuter+1][0]);
                }
            }
        }

      for (iOuter = 0; iOuter < iMaxX; iOuter++)
        *dstStream << " ##";
      *dstStream << endl << endl;


      sComment << '\0';
      pcDummy = sComment.str();
      if (pcDummy[0] != '\0')
        *dstStream << pcDummy;
      
      delete pcDummy;
      
      *dstStream << "converted by elementarySoftwork's MazeConvert" << endl;
    }


  if (srcFile)
    {
      srcFile->close ();
      delete srcFile;
    }

  if (dstFile)
    {
      dstFile->close ();
      delete dstFile;
    }

}
