/*=============================================================================
 *                          Softwarepraktikum iMaze
 *                                 1993/94
 *                    Joerg Czeranski    Hans-Ulrich Kiel
 *                              Tim Wittrock
 *-----------------------------------------------------------------------------
 * X_icon.c,v
 * Revision 1.4  1997/05/19 14:28:28  tim
 * RCS-version
 *
 *-----------------------------------------------------------------------------
 * Kommentar:
 *  Erzeugt eine Icon-Pixmap
 *===========================================================================*/

#include <stdio.h>
#include <X11/X.h>
#include <X11/Xlib.h>

#include "X_icon.h"

static char rcsid[] = "X_icon.c,v 1.4 1997/05/19 14:28:28 tim Exp";


#define W 48
#define H 48


static char *icon_data[H] =
{
"                                                ",
"                                                ",
"                    ++++++++                    ",
"                 +++        +++                 ",
"              +++              +++              ",
"             +                    +             ",
"           ++  +      +++          ++           ",
"          +   +++    ++++++          +          ",
"         +  +++++    +++++++          +         ",
"        +  ++++++   ++++++++           +        ",
"       +  +++++++   +++++++++           +       ",
"      +  ++++++++   +++++++++            +      ",
"      +  +++++++   ++++++++++            +      ",
"     +  ++++++++   +++++++++++            +     ",
"    +  +++++++++   +++++++++++             +    ",
"    +  ++++++++    +++++++++++             +    ",
"    +  ++++++++    +++++++++++             +    ",
"   +  +++++++++    +++++++++++              +   ",
"   +  ++++++++     +++++++++++              +   ",
"   +  +++++++      +++++++++++              +   ",
"  +   +++++++       +++++++++                +  ",
"  +   ++++++        +++++++++                +  ",
"  +    +++++         +++++++                 +  ",
"  +    ++++           +++++                  +  ",
"  +                                          +  ",
"  +                                          +  ",
"  +                                          +  ",
"  +                                          +  ",
"   +                                        +   ",
"   +                                        +   ",
"   +                                        +   ",
"    +                           ++         +    ",
"    +                           ++         +    ",
"    +                          ++          +    ",
"     + +                      +++         +     ",
"      +++                    +++         +      ",
"      + ++                  +++          +      ",
"       + ++                +++          +       ",
"        + +++            ++++          +        ",
"         + ++++       +++++           +         ",
"          +  ++++++++++++            +          ",
"           ++  ++++++++            ++           ",
"             +                    +             ",
"              +++              +++              ",
"                 +++        +++                 ",
"                    ++++++++                    ",
"                                                ",
"                                                ",
};


static Pixmap create_pixmap(display, screen, pixel_data, black, white, depth)
Display *display;
int screen;
char **pixel_data;
unsigned long black, white;
unsigned depth;
{
	Visual *visual;
	Pixmap pix;
	GC gc;
	XGCValues gc_values;
	XImage *image;
	unsigned char data[W * H / 8];
	int x, y;

	visual = DefaultVisual(display, screen);

	pix = XCreatePixmap(display, RootWindow(display, screen), W, H, depth);

	gc_values.foreground = black;
	gc_values.background = white;
	gc = XCreateGC(display, pix, GCForeground | GCBackground, &gc_values);

	image = XCreateImage(display, visual, 1, XYBitmap,
		0, data, W, H, 8, W / 8);

	for (y = 0; y < H; y++)
		for (x = 0; x < W; x++)
			XPutPixel(image, x, y, pixel_data[y][x] != ' ');

	XPutImage(display, pix, gc, image, 0, 0, 0, 0, W, H);
	XFree(image);
	XFreeGC(display, gc);

	return pix;
}


Pixmap X_create_icon_pixmap(display, screen)
Display *display;
int screen;
{
	return create_pixmap(display, screen, icon_data,
		BlackPixel(display, screen), WhitePixel(display, screen),
		DefaultDepth(display, screen));
}
